<template>
	<div class="create-sampling-collection-button">
		<v-btn color="primary" rounded :disabled="disabled" @click="handleClick(false)">Collect</v-btn>
		<div v-if="disabled" class="create-sampling-collection-button--disabled-text caption grey--text mt-1 ml-1">
			Collection cannot be started until the field is stratified.
		</div>
		<confirm-dialog
			v-model="showChooseSamplingCollectionDialog"
			title="Begin Sampling Collection"
			message="You already have an in-progress sampling collection for this field. Choose a sampling collection to resume or start a new sampling collection."
			button="New Collection"
			button-color="green"
			@confirm="handleClick(true)"
		>
			<template slot="content-footer">
				<v-list dense>
					<v-list-item dense v-for="samplingCollection in draftSamplingCollections" :key="samplingCollection.id">
						<router-link :to="`/sampling-collection/${samplingCollection.id}/edit`">
							{{ new Date(samplingCollection.dateCreated).toLocaleString() }}
						</router-link>
					</v-list-item>
				</v-list>
			</template>
		</confirm-dialog>
	</div>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/composition-api';
import ConfirmDialog from '@/components/dialog/ConfirmDialog.vue';
import { SamplingCollection } from '@/store/types';

export default defineComponent({
	name: 'CreateSamplingCollectionButton',
	components: { ConfirmDialog },
	props: {
		fieldId: {
			type: String,
			required: true,
		},
		locationCollectionId: {
			type: String,
		},
		draftSamplingCollections: {
			type: Array as () => SamplingCollection[],
		},
	},
	setup({ fieldId, locationCollectionId, draftSamplingCollections }, { root }) {
		const showChooseSamplingCollectionDialog = ref(false);
		return {
			handleClick(forceCreate: boolean) {
				if (forceCreate || !draftSamplingCollections || draftSamplingCollections.length === 0) {
					root.$router.push({
						path: '/create-sampling-collection',
						query: {
							field: fieldId,
							object: locationCollectionId,
						},
					});
				} else {
					showChooseSamplingCollectionDialog.value = true;
				}
			},
			disabled: !locationCollectionId,
			showChooseSamplingCollectionDialog,
		};
	},
});
</script>

<style>
.create-sampling-collection-button--disabled-text {
	max-width: 180px;
}
</style>
